cpcFaceplateButtonState_ButtonSetState(dyn_string dsButtons, dyn_string dsUserAccess, string deviceName, string sDpType, dyn_string dsData, dyn_string &exceptionInfo)
{
	bool locked = dsData[1];
	string selectedManager = dsData[2];
	string localManager = unSelectDeselectHMI_getSelectedState(locked, selectedManager);
	bool selected = (localManager == "S");
	for (int i = 1; i <= dynlen(dsButtons); i++) {
		dyn_string tmpExceptionInfo;
		string accessMethod;
		string accessMethod = "cpcFaceplateButtonState_" + sDpType + "_" + dsButtons[i];
		if (!isFunctionDefined(accessMethod)) {
			accessMethod = "cpcFaceplateButtonState_" + dsButtons[i];
		}
		evalScript(tmpExceptionInfo, "dyn_string main(string deviceName, string sDpType, bool buttonEnabled, bool selected, dyn_string dsData) {" + 
				"dyn_string exceptionInfo;" +
				accessMethod  + "(deviceName, sDpType, buttonEnabled, selected, dsData, exceptionInfo);" +
				"return exceptionInfo; }", makeDynString(), deviceName, sDpType, dynContains(dsUserAccess, dsButtons[i]) > 0, selected, dsData);
		dynAppend(exceptionInfo, tmpExceptionInfo);
	}
}


cpcFaceplateButtonState_AllowRestart(string deviceName, string sDpType, bool buttonEnabled, bool selected, dyn_string dsData, dyn_string &exceptionInfo)
{
    string font;
    bool bMRestart = cpcGenericDpFunctions_getDeviceProperty(deviceName, CPC_PARAMS_MRESTART, exceptionInfo);
    bool bRstartFS = cpcGenericDpFunctions_getDeviceProperty(deviceName, CPC_PARAMS_RSTARTFS, exceptionInfo);
    if (bMRestart) {
        bit32 stsReg01Value = dsData[3];
        bool bStsReg01Bad = dsData[4];
        bit32 stsReg02Value = dsData[5];
        bool bStsReg02Bad = dsData[6];
        buttonEnabled = buttonEnabled && selected &&
                !getBit(stsReg01Value, UN_STSREG01_ALUNACK) &&
                (!getBit(stsReg02Value, CPC_STSREG02_FUSTOPIST) || bRstartFS) &&
                !getBit(stsReg01Value, UN_STSREG01_LDST) &&
                !getBit(stsReg02Value, CPC_STSREG02_SOFTLDST) &&
                !getBit(stsReg02Value, CPC_STSREG02_NEEDRESTART) &&
                !bStsReg01Bad && !bStsReg02Bad;
        font = "-11,0,0,0,700,0,0,0,0,3,2,1,34,Arial";
    } else {
        buttonEnabled = false;
        font = "-11,0,0,0,700,0,0,1,0,3,2,1,34,Arial";
    }

    setMultiValue(UN_FACEPLATE_BUTTON_PREFIX + CPC_FACEPLATE_BUTTON_ALLOW_RESTART, "enabled", buttonEnabled,
                  UN_FACEPLATE_BUTTON_PREFIX + CPC_FACEPLATE_BUTTON_ALLOW_RESTART, "font", font);
}

cpcFaceplateButtonState_ProcessControlObject_AllowRestart(string deviceName, string sDpType, bool buttonEnabled, bool selected, dyn_string dsData, dyn_string &exceptionInfo)
{
	string font;
	bool bMRestart = cpcGenericDpFunctions_getDeviceProperty(deviceName, CPC_PARAMS_MRESTART, exceptionInfo);
	bool bRstartFS = cpcGenericDpFunctions_getDeviceProperty(deviceName, CPC_PARAMS_RSTARTFS, exceptionInfo);
	if (bMRestart) {
		bit32 stsReg01Value = dsData[3];
		bool bStsReg01Bad = dsData[4];
		bit32 stsReg02Value = dsData[5];
		bool bStsReg02Bad = dsData[6];
		buttonEnabled = buttonEnabled && selected &&
				!getBit(stsReg01Value, UN_STSREG01_ALUNACK) &&
				(!getBit(stsReg01Value, UN_STSREG01_FUSTOPAL) || bRstartFS) &&
				!getBit(stsReg02Value, CPC_STSREG02_SOFTLDST) &&
				!getBit(stsReg02Value, CPC_STSREG02_NEEDRESTART) &&
				!bStsReg01Bad && !bStsReg02Bad;
		font = "Arial,8,-1,5,75,0,0,0,0,0";
	} else {
		buttonEnabled = false;
		font = "Arial,8,-1,5,75,0,0,1,0,0";
	}

	setMultiValue(UN_FACEPLATE_BUTTON_PREFIX + CPC_FACEPLATE_BUTTON_ALLOW_RESTART, "enabled", buttonEnabled,
				  UN_FACEPLATE_BUTTON_PREFIX + CPC_FACEPLATE_BUTTON_ALLOW_RESTART, "font", font);
}


cpcFaceplateButtonState_SetValue_ButtonUserAccess()
{
    bool operator, expert, admin, bActionDefined = false;
    dyn_bool dbPermissions;
    dyn_string exceptionInfo;
    string sOperAction, sExpAction, sAdminAction;

    unGenericDpFunctions_getAccessControlPriviledgeRigth($sDpName, g_dsDomainAccessControl, dbPermissions, sOperAction, sExpAction, sAdminAction, exceptionInfo);
    bActionDefined = (sOperAction != UNICOS_ACCESSCONTROL_DOMAINNAME) || (sExpAction != UNICOS_ACCESSCONTROL_DOMAINNAME) || (sAdminAction != UNICOS_ACCESSCONTROL_DOMAINNAME);
    operator = dbPermissions[2];
    expert = dbPermissions[3];
    admin = dbPermissions[4];
    g_dsUserAccess = makeDynString();
    if (operator){
        if(bActionDefined)
            dynAppend(g_dsUserAccess, strsplit(sOperAction, UN_ACCESS_CONTROL_SEPARATOR));
    }
    if (expert){
        if(bActionDefined)
            dynAppend(g_dsUserAccess, strsplit(sExpAction, UN_ACCESS_CONTROL_SEPARATOR));
        else
            dynAppend(g_dsUserAccess, makeDynString(CPC_FACEPLATE_BUTTON_SAVE_VALUE));
    }
    if(admin){
        if(bActionDefined)
           dynAppend(g_dsUserAccess, strsplit(sAdminAction, UN_ACCESS_CONTROL_SEPARATOR));
    }
}
